map $http_user_agent $gem_local_or_remote {
	default /404_site_not_found.html;
	"~x86_64-linux-musl" @gems;
	"~x86_64-alpine-linux-musl" @gems;
}

map $http_user_agent $gem_backend {
{% for gem_backend in gem_backends %}
  "~*\sruby/{{ gem_backend.ruby_version | replace('.', '\.') }}\.\d\s" {{ gem_backend.backend }};
  "~*\sRuby/{{ gem_backend.ruby_version | replace('.', '\.') }}\.\d\s" {{ gem_backend.backend }};
{% endfor %}
}

server {
  server_name gems.{{ sutty }};

  access_log syslog:server=unix:/tmp/access_log.socket,nohostname access_logd;

{% if inventory_hostname in groups.sutty_certbot %}
  include snippets/acme.conf;
{% else %}
  # Redirect to "Central Validation Server"
  location ^~ /.well-known/acme-challenge/ {
    return 301 http://certbot.{{ sutty }}$request_uri;
  }
{% endif %}

  # Ask robots to ignore us
  location = /robots.txt {
    return 200 "User-agent: *\nDisallow: /";
  }

  listen 80;
  listen 443 ssl;
  http2 on;

  add_header Cache-Control no-cache;
  add_header Strict-Transport-Security "max-age=31536000; includeSubDomains; preload";
  add_header X-Frame-Options "sameorigin";
  add_header X-XSS-Protection "1; mode=block";
  add_header X-Content-Type-Options "nosniff";
  add_header Referrer-Policy "strict-origin-when-cross-origin";
  add_header Access-Control-Allow-Origin "*";
  # TODO: Remove panel from media-src
  add_header Content-Security-Policy-Report-Only "default-src 'self'; media-src 'self' https://panel.sutty.nl; style-src 'self' 'unsafe-inline'; script-src https: 'self'; font-src data: 'self'; img-src https: 'self'; object-src 'none'; frame-src https: 'self'; connect-src 'self' https://*.sutty.nl; report-uri https://api.sutty.nl/v1/csp_reports.json";
  add_header Permissions-Policy "interest-cohort=()";

  ssl_certificate /etc/letsencrypt/live/{{ sutty }}/fullchain.pem;
  ssl_certificate_key /etc/letsencrypt/live/{{ sutty }}/privkey.pem;
  ssl_session_timeout 1d;
  ssl_session_cache shared:SSL:10m;
  ssl_session_tickets off;
  ssl_protocols TLSv1 TLSv1.1 TLSv1.2 TLSv1.3;
  ssl_early_data on;

  if ($redirect_to_https) {
    return 301 https://$http_host$request_uri;
  }

  brotli_static on;
  gzip_static on;

  root /srv/http/gems.{{ sutty }};

  # Block the Compact Index API
  # @see {https://codeberg.org/forgejo/forgejo/issues/6507}
  location = /versions {
    return 404;
  }

  location / {
     try_files $uri $uri/ $gem_local_or_remote;
   }

   location @gems {
    proxy_set_header X-Forwarded-Proto https;
    proxy_set_header Host {{ gem_hostname }};
    proxy_set_header X-Real-IP $remote_addr;
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;

    proxy_ssl_server_name on;
    proxy_ssl_name {{ gem_hostname }};
    proxy_set_header Authorization "{{ gem_authorization }}";
    proxy_pass $gem_backend;
  }
}
